BaseBpGraphComponent Class Reference

- Main Page
- Modules
- Classes
- Namespaces
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
List of all members | Classes | Public Member Functions
BaseBpGraphComponent Class Reference

## Detailed Description

This class describes the base interface of undirected bipartite graph types. All bipartite graph concepts have to conform to this class. It extends the interface of BaseGraphComponent with an `Edge` type and functions to get the end nodes of edges, to convert from arcs to edges and to get both direction of edges.

`#include <lemon/concepts/graph_components.h>`

Inheritance diagram for BaseBpGraphComponent:
[legend]

## Classes
class | BlueNode
| Class to represent blue nodes. More...
class | RedNode
| Class to represent red nodes. More...

## Public Member Functions
bool | red (const Node &) const
| Gives back true for red nodes. More...
bool | blue (const Node &) const
| Gives back true for blue nodes. More...
RedNode | redNode (const Edge &) const
| Gives back the red end node of the edge. More...
BlueNode | blueNode (const Edge &) const
| Gives back the blue end node of the edge. More...
RedNode | asRedNodeUnsafe (const Node &) const
| Converts the node to red node object. More...
BlueNode | asBlueNodeUnsafe (const Node &) const
| Converts the node to blue node object. More...
RedNode | asRedNode (const Node &) const
| Converts the node to red node object. More...
BlueNode | asBlueNode (const Node &) const
| Converts the node to blue node object. More...
Public Member Functions inherited from BaseGraphComponent
Node | u (const Edge &) const
| Return one end node of an edge. More...
Node | v (const Edge &) const
| Return the other end node of an edge. More...
Arc | direct (const Edge &, bool) const
| Return a directed arc related to an edge. More...
Arc | direct (const Edge &, const Node &) const
| Return a directed arc related to an edge. More...
bool | direction (const Arc &) const
| Return the direction of the arc. More...
Arc | oppositeArc (const Arc &) const
| Return the opposite arc. More...
Public Member Functions inherited from BaseDigraphComponent
Node | source (const Arc &) const
| Return the source node of an arc. More...
Node | target (const Arc &) const
| Return the target node of an arc. More...
Node | oppositeNode (const Node &, const Arc &) const
| Return the opposite node on the given arc. More...

## Additional Inherited Members
Public Types inherited from BaseDigraphComponent
typedef GraphItem<'n'> | Node
| Node class of the digraph. More...
typedef GraphItem<'a'> | Arc
| Arc class of the digraph. More...

## Member Function Documentation

bool red | ( | const Node & |  | ) | const
| inline

Gives back true for red nodes.

bool blue | ( | const Node & |  | ) | const
| inline

Gives back true for blue nodes.

RedNode redNode | ( | const Edge & |  | ) | const
| inline

Gives back the red end node of the edge.

BlueNode blueNode | ( | const Edge & |  | ) | const
| inline

Gives back the blue end node of the edge.

RedNode asRedNodeUnsafe | ( | const Node & |  | ) | const
| inline

This function converts unsafely the node to red node object. It should be called only if the node is from the red partition or INVALID.

BlueNode asBlueNodeUnsafe | ( | const Node & |  | ) | const
| inline

This function converts unsafely the node to blue node object. It should be called only if the node is from the red partition or INVALID.

RedNode asRedNode | ( | const Node & |  | ) | const
| inline

This function converts safely the node to red node object. If the node is not from the red partition, then it returns INVALID.

BlueNode asBlueNode | ( | const Node & |  | ) | const
| inline

This function converts unsafely the node to blue node object. If the node is not from the blue partition, then it returns INVALID.